//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3F680334.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3F680334.cm

//## begin module%3EEB3F680334.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3F680334.cp

//## Module: FlowSink%3EEB3F680334; Package specification
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\FlowSink.h

#ifndef FlowSink_h
#define FlowSink_h 1

//## begin module%3EEB3F680334.additionalIncludes preserve=no
//## end module%3EEB3F680334.additionalIncludes

//## begin module%3EEB3F680334.includes preserve=yes
#include "AbstractConcepts.h"
//## end module%3EEB3F680334.includes

//## begin module%3EEB3F680334.declarations preserve=no
//## end module%3EEB3F680334.declarations

//## begin module%3EEB3F680334.additionalDeclarations preserve=yes
//## end module%3EEB3F680334.additionalDeclarations


//## begin FlowSink%3EE0A7DD0258.preface preserve=yes
//## end FlowSink%3EE0A7DD0258.preface

//## Class: FlowSink%3EE0A7DD0258
//	An element that accepts all incoming traffic flow and
//	does not propagate it further - a termination of a flow
//	branch.
//## Category: Traffic Modeling and Simulation::Concepts::Modeling Concepts%3EE0C1CA01A4
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class FlowSink : public FlowElement  //## Inherits: <unnamed>%3EE0A8CD019A
{
  //## begin FlowSink%3EE0A7DD0258.initialDeclarations preserve=yes
  //## end FlowSink%3EE0A7DD0258.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: FlowSink%3EE0A85501C2
      //	Constructor.
      FlowSink ();


    //## Other Operations (specified)
      //## Operation: accept%3EEB1192032A
      //	Accepts a Visitor. Visitor DP.
      virtual void accept (Visitor* vis);

    // Additional Public Declarations
      //## begin FlowSink%3EE0A7DD0258.public preserve=yes
      //## end FlowSink%3EE0A7DD0258.public

  protected:

    //## Other Operations (specified)
      //## Operation: process%3EE0A85501C3
      //	Redefined. Sinks the input flow.
      virtual void process ();

    // Additional Protected Declarations
      //## begin FlowSink%3EE0A7DD0258.protected preserve=yes
      //## end FlowSink%3EE0A7DD0258.protected

  private:
    // Additional Private Declarations
      //## begin FlowSink%3EE0A7DD0258.private preserve=yes
      //## end FlowSink%3EE0A7DD0258.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin FlowSink%3EE0A7DD0258.implementation preserve=yes
      //## end FlowSink%3EE0A7DD0258.implementation

};

//## begin FlowSink%3EE0A7DD0258.postscript preserve=yes
//## end FlowSink%3EE0A7DD0258.postscript

// Class FlowSink 

inline FlowSink::FlowSink ()
  //## begin FlowSink::FlowSink%3EE0A85501C2.hasinit preserve=no
  //## end FlowSink::FlowSink%3EE0A85501C2.hasinit
  //## begin FlowSink::FlowSink%3EE0A85501C2.initialization preserve=yes
  //## end FlowSink::FlowSink%3EE0A85501C2.initialization
{
  //## begin FlowSink::FlowSink%3EE0A85501C2.body preserve=yes
  //## end FlowSink::FlowSink%3EE0A85501C2.body
}



//## Other Operations (inline)
inline void FlowSink::process ()
{
  //## begin FlowSink::process%3EE0A85501C3.body preserve=yes
  //## end FlowSink::process%3EE0A85501C3.body
}

//## begin module%3EEB3F680334.epilog preserve=yes
//## end module%3EEB3F680334.epilog


#endif
