//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3F480316.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3F480316.cm

//## begin module%3EEB3F480316.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3F480316.cp

//## Module: FlowSource%3EEB3F480316; Package body
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\FlowSource.cpp

//## begin module%3EEB3F480316.additionalIncludes preserve=no
//## end module%3EEB3F480316.additionalIncludes

//## begin module%3EEB3F480316.includes preserve=yes
#include "ExpRndGen.h"
#include "Visitor.h"
//## end module%3EEB3F480316.includes

// FlowSource
#include "FlowSource.h"
//## begin module%3EEB3F480316.declarations preserve=no
//## end module%3EEB3F480316.declarations

//## begin module%3EEB3F480316.additionalDeclarations preserve=yes
//## end module%3EEB3F480316.additionalDeclarations


// Class FlowSource 


FlowSource::FlowSource (double meanValue)
  //## begin FlowSource::FlowSource%3EE0A61E01CC.hasinit preserve=no
      : onOff(true)
  //## end FlowSource::FlowSource%3EE0A61E01CC.hasinit
  //## begin FlowSource::FlowSource%3EE0A61E01CC.initialization preserve=yes
  , RandomTimedFlowElement(new ExpGenerator(meanValue))
  //## end FlowSource::FlowSource%3EE0A61E01CC.initialization
{
  //## begin FlowSource::FlowSource%3EE0A61E01CC.body preserve=yes
	raiseEvent();
  //## end FlowSource::FlowSource%3EE0A61E01CC.body
}



//## Other Operations (implementation)
void FlowSource::accept (Visitor* vis)
{
  //## begin FlowSource::accept%3EEB11550348.body preserve=yes
	if (vis) vis->visitFlowSource(this);
  //## end FlowSource::accept%3EEB11550348.body
}

void FlowSource::notify (ID )
{
  //## begin FlowSource::notify%3EE0929902D0.body preserve=yes
	if (isOn()) {
		counter++;
		send();
	}
	raiseEvent();
  //## end FlowSource::notify%3EE0929902D0.body
}

// Additional Declarations
  //## begin FlowSource%3EE087670140.declarations preserve=yes
  //## end FlowSource%3EE087670140.declarations

//## begin module%3EEB3F480316.epilog preserve=yes
//## end module%3EEB3F480316.epilog
