//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB3FA601F4.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB3FA601F4.cm

//## begin module%3EEB3FA601F4.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB3FA601F4.cp

//## Module: Pipe%3EEB3FA601F4; Package body
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\Pipe.cpp

//## begin module%3EEB3FA601F4.additionalIncludes preserve=no
//## end module%3EEB3FA601F4.additionalIncludes

//## begin module%3EEB3FA601F4.includes preserve=yes
#include "Visitor.h"
#include "ExpRndGen.h"
//## end module%3EEB3FA601F4.includes

// Pipe
#include "Pipe.h"
//## begin module%3EEB3FA601F4.declarations preserve=no
//## end module%3EEB3FA601F4.declarations

//## begin module%3EEB3FA601F4.additionalDeclarations preserve=yes
//## end module%3EEB3FA601F4.additionalDeclarations


// Class Pipe 

Pipe::Pipe (double meanValue)
  //## begin Pipe::Pipe%3EE0AB2E0096.hasinit preserve=no
  //## end Pipe::Pipe%3EE0AB2E0096.hasinit
  //## begin Pipe::Pipe%3EE0AB2E0096.initialization preserve=yes
  : RandomTimedFlowElement(new ExpGenerator(meanValue))
  //## end Pipe::Pipe%3EE0AB2E0096.initialization
{
  //## begin Pipe::Pipe%3EE0AB2E0096.body preserve=yes
  //## end Pipe::Pipe%3EE0AB2E0096.body
}



//## Other Operations (implementation)
void Pipe::accept (Visitor* vis)
{
  //## begin Pipe::accept%3EEB11BB01C2.body preserve=yes
	if (vis) vis->visitPipe(this);
  //## end Pipe::accept%3EEB11BB01C2.body
}

void Pipe::process ()
{
  //## begin Pipe::process%3EE0AFE00168.body preserve=yes
	raiseEvent();
  //## end Pipe::process%3EE0AFE00168.body
}

void Pipe::notify (ID )
{
  //## begin Pipe::notify%3EE0AFE00169.body preserve=yes
	send();
  //## end Pipe::notify%3EE0AFE00169.body
}

// Additional Declarations
  //## begin Pipe%3EE0AA9501FE.declarations preserve=yes
  //## end Pipe%3EE0AA9501FE.declarations

//## begin module%3EEB3FA601F4.epilog preserve=yes
//## end module%3EEB3FA601F4.epilog
