//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB42170032.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB42170032.cm

//## begin module%3EEB42170032.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB42170032.cp

//## Module: VModelDocumenter%3EEB42170032; Package specification
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VModelDocumenter.h

#ifndef VModelDocumenter_h
#define VModelDocumenter_h 1

//## begin module%3EEB42170032.additionalIncludes preserve=no
//## end module%3EEB42170032.additionalIncludes

//## begin module%3EEB42170032.includes preserve=yes
#include "VTxtOutputGen.h"
//## end module%3EEB42170032.includes

//## begin module%3EEB42170032.declarations preserve=no
//## end module%3EEB42170032.declarations

//## begin module%3EEB42170032.additionalDeclarations preserve=yes
//## end module%3EEB42170032.additionalDeclarations


//## begin VisModelDocumenter%3EEB1833023A.preface preserve=yes
//## end VisModelDocumenter%3EEB1833023A.preface

//## Class: VisModelDocumenter%3EEB1833023A
//	A Visitor that traverses the model and generates the
//	documentation.
//## Category: Traffic Modeling and Simulation::Visitors%3EEB0CA50186
//## Subsystem: Visitors%3EEB3A5302B2
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class VisModelDocumenter : public VisTxtOutputGenerator  //## Inherits: <unnamed>%3EEB1833026F
{
  //## begin VisModelDocumenter%3EEB1833023A.initialDeclarations preserve=yes
  //## end VisModelDocumenter%3EEB1833023A.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: VisModelDocumenter%3EEB1833023B
      //	Constructor. Accepts an output stream to generate the
      //	report.
      VisModelDocumenter (ostream* output);


    //## Other Operations (specified)
      //## Operation: visitUniformGenerator%3EEB1833023D
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitUniformGenerator (UniformGenerator* e);

      //## Operation: visitExpGenerator%3EEB1833023F
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitExpGenerator (ExpGenerator* e);

      //## Operation: visitFlowSource%3EEB18330241
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSource (FlowSource* e);

      //## Operation: visitFlowSink%3EEB18330243
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSink (FlowSink* e);

      //## Operation: visitPipe%3EEB18330245
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitPipe (Pipe* e);

      //## Operation: visitQueuedServer%3EEB18330247
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitQueuedServer (QueuedServer* e);

      //## Operation: visitSwitch1to3%3EEB18330249
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitSwitch1to3 (Switch1to3* e);

      //## Operation: visitCrossSemaphore%3EEB1833026D
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitCrossSemaphore (CrossSemaphore* e);

    // Additional Public Declarations
      //## begin VisModelDocumenter%3EEB1833023A.public preserve=yes
      //## end VisModelDocumenter%3EEB1833023A.public

  protected:

    //## Other Operations (specified)
      //## Operation: visitModelElement%3EEF48C60140
      //	Helper. Visits a Model Element. Writes its ID, name, and
      //	description.
      virtual void visitModelElement (ModelElement* me, char* typeStr);

      //## Operation: visitFlowElement%3EEF48F802E4
      //	Helper. Visits a Flow Element. Writes its ID, name,
      //	description, the target's data, and the number of
      //	transported occurrences.
      virtual void visitFlowElement (FlowElement* fe, char* typeStr);

    // Additional Protected Declarations
      //## begin VisModelDocumenter%3EEB1833023A.protected preserve=yes
      //## end VisModelDocumenter%3EEB1833023A.protected

  private:
    // Additional Private Declarations
      //## begin VisModelDocumenter%3EEB1833023A.private preserve=yes
      //## end VisModelDocumenter%3EEB1833023A.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin VisModelDocumenter%3EEB1833023A.implementation preserve=yes
      //## end VisModelDocumenter%3EEB1833023A.implementation

};

//## begin VisModelDocumenter%3EEB1833023A.postscript preserve=yes
//## end VisModelDocumenter%3EEB1833023A.postscript

// Class VisModelDocumenter 

inline VisModelDocumenter::VisModelDocumenter (ostream* output)
  //## begin VisModelDocumenter::VisModelDocumenter%3EEB1833023B.hasinit preserve=no
  //## end VisModelDocumenter::VisModelDocumenter%3EEB1833023B.hasinit
  //## begin VisModelDocumenter::VisModelDocumenter%3EEB1833023B.initialization preserve=yes
  : VisTxtOutputGenerator(output)
  //## end VisModelDocumenter::VisModelDocumenter%3EEB1833023B.initialization
{
  //## begin VisModelDocumenter::VisModelDocumenter%3EEB1833023B.body preserve=yes
  //## end VisModelDocumenter::VisModelDocumenter%3EEB1833023B.body
}


//## begin module%3EEB42170032.epilog preserve=yes
//## end module%3EEB42170032.epilog


#endif
