//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB41BE00BE.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB41BE00BE.cm

//## begin module%3EEB41BE00BE.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB41BE00BE.cp

//## Module: VTxtOutputGen%3EEB41BE00BE; Package body
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\VTxtOutputGen.cpp

//## begin module%3EEB41BE00BE.additionalIncludes preserve=no
//## end module%3EEB41BE00BE.additionalIncludes

//## begin module%3EEB41BE00BE.includes preserve=yes
#include <iostream.h>
#include "AbstractConcepts.h"
//## end module%3EEB41BE00BE.includes

// VTxtOutputGen
#include "VTxtOutputGen.h"
//## begin module%3EEB41BE00BE.declarations preserve=no
//## end module%3EEB41BE00BE.declarations

//## begin module%3EEB41BE00BE.additionalDeclarations preserve=yes
//## end module%3EEB41BE00BE.additionalDeclarations


// Class VisTxtOutputGenerator 


VisTxtOutputGenerator::VisTxtOutputGenerator (ostream* outputStream)
  //## begin VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.hasinit preserve=no
      : out(outputStream)
  //## end VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.hasinit
  //## begin VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.initialization preserve=yes
  //## end VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.initialization
{
  //## begin VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.body preserve=yes
  //## end VisTxtOutputGenerator::VisTxtOutputGenerator%3EEB1437017C.body
}



//## Other Operations (implementation)
void VisTxtOutputGenerator::output (char* str)
{
  //## begin VisTxtOutputGenerator::output%3EEB1476010E.body preserve=yes
	if (out && str) (*out)<<str;
  //## end VisTxtOutputGenerator::output%3EEB1476010E.body
}

void VisTxtOutputGenerator::writeNameType (ModelElement* me, char* typeName)
{
  //## begin VisTxtOutputGenerator::writeNameType%3EEE07B5029E.body preserve=yes
	if (me && out) {
		(*out)<<"[ID="<<me->getID()<<"] ";
		output(me->getName());
		output(" : ");
		output(typeName);
	}
  //## end VisTxtOutputGenerator::writeNameType%3EEE07B5029E.body
}

void VisTxtOutputGenerator::writeDescrLn (ModelElement* me)
{
  //## begin VisTxtOutputGenerator::writeDescrLn%3EEE080B0208.body preserve=yes
	if (me) {
		output("Description: ");
		output(me->getDescr());
		output("\n");
	}
  //## end VisTxtOutputGenerator::writeDescrLn%3EEE080B0208.body
}

// Additional Declarations
  //## begin VisTxtOutputGenerator%3EEB13C800D2.declarations preserve=yes
  //## end VisTxtOutputGenerator%3EEB13C800D2.declarations

//## begin module%3EEB41BE00BE.epilog preserve=yes
//## end module%3EEB41BE00BE.epilog
