//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB40290000.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB40290000.cm

//## begin module%3EEB40290000.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB40290000.cp

//## Module: CrossSem%3EEB40290000; Package body
//## Subsystem: Concepts::Modeling Concepts%3EEC428203DE
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Concepts\Modeling Concepts\CrossSem.cpp

//## begin module%3EEB40290000.additionalIncludes preserve=no
//## end module%3EEB40290000.additionalIncludes

//## begin module%3EEB40290000.includes preserve=yes
#include "Visitor.h"
#include "Event.h"
//## end module%3EEB40290000.includes

// CrossSem
#include "CrossSem.h"


//## begin module%3EEB40290000.declarations preserve=no
//## end module%3EEB40290000.declarations

//## begin module%3EEB40290000.additionalDeclarations preserve=yes
//## end module%3EEB40290000.additionalDeclarations


// Class CrossSemaphore 






CrossSemaphore::CrossSemaphore (Time timeVertical, Time timeHorizontal)
  //## begin CrossSemaphore::CrossSemaphore%3EE0C2C1008C.hasinit preserve=no
      : curDir(horizontal),
        tVer(1),
        tHor(1)
  //## end CrossSemaphore::CrossSemaphore%3EE0C2C1008C.hasinit
  //## begin CrossSemaphore::CrossSemaphore%3EE0C2C1008C.initialization preserve=yes
  //## end CrossSemaphore::CrossSemaphore%3EE0C2C1008C.initialization
{
  //## begin CrossSemaphore::CrossSemaphore%3EE0C2C1008C.body preserve=yes
	horSource[0]=horSource[1]=0;
	verSource[0]=verSource[1]=0;
	setTimes(timeVertical,timeHorizontal);
	notify(0);
  //## end CrossSemaphore::CrossSemaphore%3EE0C2C1008C.body
}



//## Other Operations (implementation)
void CrossSemaphore::accept (Visitor* vis)
{
  //## begin CrossSemaphore::accept%3EEB11F80244.body preserve=yes
	if (vis) vis->visitCrossSemaphore(this);
  //## end CrossSemaphore::accept%3EEB11F80244.body
}

void CrossSemaphore::notify (ID )
{
  //## begin CrossSemaphore::notify%3EE0C2E40046.body preserve=yes
	if (curDir==horizontal) {
		if (horSource[0]) horSource[0]->switchOff();
		if (horSource[1]) horSource[1]->switchOff();
		curDir = vertical;
		if (verSource[0]) verSource[0]->switchOn();
		if (verSource[1]) verSource[1]->switchOn();
		Event::create(this,tVer);
	} else {
		if (verSource[0]) verSource[0]->switchOff();
		if (verSource[1]) verSource[1]->switchOff();
		curDir = horizontal;
		if (horSource[0]) horSource[0]->switchOn();
		if (horSource[1]) horSource[1]->switchOn();
		Event::create(this,tHor);
	}
  //## end CrossSemaphore::notify%3EE0C2E40046.body
}

// Additional Declarations
  //## begin CrossSemaphore%3EE0C298014A.declarations preserve=yes
  //## end CrossSemaphore%3EE0C298014A.declarations

//## begin module%3EEB40290000.epilog preserve=yes
//## end module%3EEB40290000.epilog
