//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB41720186.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB41720186.cm

//## begin module%3EEB41720186.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB41720186.cp

//## Module: Visitor%3EEB41720186; Package specification
//## Subsystem: Visitors%3EEB3A5302B2
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Visitors\Visitor.h

#ifndef Visitor_h
#define Visitor_h 1

//## begin module%3EEB41720186.additionalIncludes preserve=no
//## end module%3EEB41720186.additionalIncludes

//## begin module%3EEB41720186.includes preserve=yes
//## end module%3EEB41720186.includes

//## begin module%3EEB41720186.declarations preserve=no
//## end module%3EEB41720186.declarations

//## begin module%3EEB41720186.additionalDeclarations preserve=yes
class Model;

class UniformGenerator;
class ExpGenerator;

class FlowSource;
class FlowSink;
class Pipe;
class QueuedServer;
class Switch1to3;
class CrossSemaphore;
//## end module%3EEB41720186.additionalDeclarations


//## begin Visitor%3EEB0DB60104.preface preserve=yes
//## end Visitor%3EEB0DB60104.preface

//## Class: Visitor%3EEB0DB60104; Abstract
//	Abstract generalizations of all kinds of visitors (i.e.,
//	model traversal strategies). Visitor DP.
//## Category: Traffic Modeling and Simulation::Visitors%3EEB0CA50186
//## Subsystem: Visitors%3EEB3A5302B2
//## Persistence: Transient
//## Cardinality/Multiplicity: n

class Visitor 
{
  //## begin Visitor%3EEB0DB60104.initialDeclarations preserve=yes
  //## end Visitor%3EEB0DB60104.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: visitModel%3EEB27F50082
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitModel (Model* e);

      //## Operation: visitUniformGenerator%3EEB0E1000E6
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitUniformGenerator (UniformGenerator* e);

      //## Operation: visitExpGenerator%3EEB12F3028A
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitExpGenerator (ExpGenerator* e);

      //## Operation: visitFlowSource%3EEB132A02E4
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSource (FlowSource* e);

      //## Operation: visitFlowSink%3EEB13400226
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitFlowSink (FlowSink* e);

      //## Operation: visitPipe%3EEB13530000
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitPipe (Pipe* e);

      //## Operation: visitQueuedServer%3EEB13650082
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitQueuedServer (QueuedServer* e);

      //## Operation: visitSwitch1to3%3EEB137F021C
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitSwitch1to3 (Switch1to3* e);

      //## Operation: visitCrossSemaphore%3EEB13980172
      //	Visits the specific kind of object. Visitor DP.
      virtual void visitCrossSemaphore (CrossSemaphore* e);

    // Additional Public Declarations
      //## begin Visitor%3EEB0DB60104.public preserve=yes
      //## end Visitor%3EEB0DB60104.public

  protected:
    // Additional Protected Declarations
      //## begin Visitor%3EEB0DB60104.protected preserve=yes
      //## end Visitor%3EEB0DB60104.protected

  private:
    // Additional Private Declarations
      //## begin Visitor%3EEB0DB60104.private preserve=yes
      //## end Visitor%3EEB0DB60104.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Visitor%3EEB0DB60104.implementation preserve=yes
      //## end Visitor%3EEB0DB60104.implementation

};

//## begin Visitor%3EEB0DB60104.postscript preserve=yes
//## end Visitor%3EEB0DB60104.postscript

// Class Visitor 


//## Other Operations (inline)
inline void Visitor::visitUniformGenerator (UniformGenerator* e)
{
  //## begin Visitor::visitUniformGenerator%3EEB0E1000E6.body preserve=yes
  //## end Visitor::visitUniformGenerator%3EEB0E1000E6.body
}

inline void Visitor::visitExpGenerator (ExpGenerator* e)
{
  //## begin Visitor::visitExpGenerator%3EEB12F3028A.body preserve=yes
  //## end Visitor::visitExpGenerator%3EEB12F3028A.body
}

inline void Visitor::visitFlowSource (FlowSource* e)
{
  //## begin Visitor::visitFlowSource%3EEB132A02E4.body preserve=yes
  //## end Visitor::visitFlowSource%3EEB132A02E4.body
}

inline void Visitor::visitFlowSink (FlowSink* e)
{
  //## begin Visitor::visitFlowSink%3EEB13400226.body preserve=yes
  //## end Visitor::visitFlowSink%3EEB13400226.body
}

inline void Visitor::visitPipe (Pipe* e)
{
  //## begin Visitor::visitPipe%3EEB13530000.body preserve=yes
  //## end Visitor::visitPipe%3EEB13530000.body
}

inline void Visitor::visitQueuedServer (QueuedServer* e)
{
  //## begin Visitor::visitQueuedServer%3EEB13650082.body preserve=yes
  //## end Visitor::visitQueuedServer%3EEB13650082.body
}

inline void Visitor::visitSwitch1to3 (Switch1to3* e)
{
  //## begin Visitor::visitSwitch1to3%3EEB137F021C.body preserve=yes
  //## end Visitor::visitSwitch1to3%3EEB137F021C.body
}

inline void Visitor::visitCrossSemaphore (CrossSemaphore* e)
{
  //## begin Visitor::visitCrossSemaphore%3EEB13980172.body preserve=yes
  //## end Visitor::visitCrossSemaphore%3EEB13980172.body
}

//## begin module%3EEB41720186.epilog preserve=yes
//## end module%3EEB41720186.epilog


#endif

